<?php

Core::load('CMS.Stockroom.Entity', 'CMS.Stockroom.Manager', 'CMS.Stockroom.Router');

/**
 * @package CMS\Stockroom
 */
class CMS_Stockroom implements Core_ModuleInterface
{
	protected static $disabled = false;
	protected static $name = 'CMSStockroom';
	static $admin_menu_title = 'Библиотека компонентов';

	public static function initialize($config = array())
	{
		foreach ($config as $key => $value) {
			if (isset(self::$$key)) {
				self::$$key = $value;
			}
		}
		if (self::$disabled) {
			return;
		}
		self::manager()->configure($config);
		CMS::add_component(self::$name, self::router());
		CMS_Admin::menu(self::$admin_menu_title, CMS::admin_path('stockroom'), 'bookshelf.png');
	}

	/**
	 * @return CMS_Stockroom_Manager
	 */
	public static function manager()
	{
		return CMS_Stockroom_Manager::instance();
	}

	protected static function router()
	{
		return new CMS_Stockroom_Router();
	}

}

class CMS_Stockroom_Exception extends Core_Exception
{

}



