<?php

use Techart\Frontend\EnvironmentStorageInterface;

class Templates_HTML_Assets_EnvironmentStorage implements Core_ModuleInterface, EnvironmentStorageInterface
{
	private $config;
	private $request;

	public function __construct($config, $request)
	{
		$this->config = $config;
		$this->request = $request;
	}

	public function getFromConfig($name)
	{
		if (!property_exists($this->config, $name)) {
			return null;
		}
		return $this->config->{$name};
	}

	public function getFromRequest($name)
	{
		return $this->request[$name];
	}

	public function getFromSession($name)
	{
		$session = $this->request->session();
		if($session instanceof Net_HTTP_Session_Store) {
			return $session->get($name);
		} elseif (is_array($session)) {
			return $session[$name];
		}
		return null;
	}

	public function setToSession($name, $value)
	{
		$session = $this->request->session();
		if($session instanceof Net_HTTP_Session_Store) {
			$session->set($name, $value);
		} elseif(is_array($session)) {
			$session[$name] = $value;
		}
	}
}